//{$WARNINGS OFF}
//=============================================================================
//  GNZtH[Ex@eXgvO
//
//  f[^x[Xf[^捞ރeXg
//
//-----------------------------------------------------------------------------
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit DBTestUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, plExcelEx, ToolWin, ComCtrls, ExtCtrls, DB,
  ADODB;

type
  TplExcelFormEx2 = class(TplExcelFormEx)
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    Memo2: TMemo;
    ADOConnection1: TADOConnection;
    ADOQuery1: TADOQuery;
    Button3: TButton;
    Memo3: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  plExcelFormEx2: TplExcelFormEx2;

implementation

uses MMSystem;

{$R *.dfm}

//=============================================================================
//  tH[\Jn̏
//=============================================================================
procedure TplExcelFormEx2.FormShow(Sender: TObject);
begin
  //XN[͈
  xlfScrollArea := 'A1:H80';

  //Nɕ\ubN̎w
  xlfBookFullPath := ExtractFilePath(Application.ExeName) + 'DBTestBook.xls';

  inherited;
end;

//=============================================================================
//  PɃZɃf[^@
//  xlfExcelSheet.Cells,OleVariantłȂ,RangeŒ`ƃR[h⊮@\
//  płĕ֗.xIɂL.
//=============================================================================
procedure TplExcelFormEx2.Button1Click(Sender: TObject);
var
  DBPath      : String;
  ConnectStr  : String;
  RecCnt      : Integer;
  i           : Integer;
  j           : Integer;
  StartRow    : Integer;
  StartRowStr : String;
  EndRowStr   : String;
  TStart      : DWORD;
  TEnd        : DWORD;
  ARange      : Txlf2000Range;
begin
  //ADO֌W̐ݒ
  //܂f[^x[Xt@C̏ꏊDBPathɑ
  DBPath := GetEnvironmentVariable('CommonProgramFiles');
  {$IF CompilerVersion > 18.49}
  DBPath := DBPath + '\CodeGear Shared\Data\dbdemos.mdb';
  {$ELSE}
  DBPath := DBPath + '\Borland Shared\Data\dbdemos.mdb';
  {$IFEND}

  ADOConnection1.Connected := False;
  //ڑ̍쐬(pX[hȂ̏ꍇ)
  ConnectStr                      := 'Provider=Microsoft.Jet.OLEDB.4.0';
  ConnectStr                      := ConnectStr + ';Data Source=' + DBPath;
  ADOConnection1.ConnectionString := ConnectStr;
  ADOConnection1.Mode             := cmReadWrite;
  ADOQuery1.Connection            := ADOConnection1;

  //NG[s
  //RecCntR[h.ADOQuery1.RecordCountł擾\
  try
    with ADOQuery1 do begin
      Close;
      SQL.Clear;
      SQL.Add('select * from customer');
      Open;
    end;
  except
    exit;
  end;

  //R[h
  RecCnt := ADOQuery1.RecordCount;

  //ݔ͈͂̃ZNA
  StartRow    := 7;
  StartRowStr := 'C' + IntToStr(StartRow);
  EndRowStr   := 'F' + IntToStr(StartRow + RecCnt - 1);
  xlfClearRange(StartRowStr,EndRowStr);

  LockWindowUpdate(PanelLeft.Handle);

  Screen.Cursor := crHourGlass;
  //Jn
  TStart := TimeGetTime;

  ARange := xlfExcelSheet.Cells;
  //3s
  with ADOQuery1 do begin
    for j := 0 to 2 do begin
      First;
      for i:=0 to RecCnt-1 do begin
        ARange.Item[i+7,3].Value := FieldByName('CustNo').AsInteger;
        ARange.Item[i+7,4].Value := FieldByName('Company').AsString;
        ARange.Item[i+7,5].Value := FieldByName('Addr1').AsString;
        ARange.Item[i+7,6].Value := FieldByName('LastInvoiceDate').AsDateTime;
        Next;
      end;
    end;
    Close;
  end;

  //I
  TEnd := TimeGetTime;
  Screen.Cursor := crDefault;

  LockWindowUpdate(0);
  //sԂ\
  Memo1.Text:=IntToStr(TEnd-TStart) + ' ms ';

  //ۑƂɂ(܂ύXȂ)
  xlfBookSaved := True;
end;

//=============================================================================
//  oAgzgp@
//  ɍɂȂD̗ႾƖ40{߂mȂ
//=============================================================================
procedure TplExcelFormEx2.Button2Click(Sender: TObject);
var
  DBPath      : String;
  ConnectStr  : String;
  RecCnt      : Integer;
  FCnt        : Integer;
  i           : Integer;
  j           : Integer;
  StartRow    : Integer;
  StartRowStr : String;
  EndRowStr   : String;
  TStart      : DWORD;
  TEnd        : DWORD;
  OleArray    : OleVariant;
begin
  //ADO֌W̐ݒ
  //܂f[^x[Xt@C̏ꏊDBPathɑ
  DBPath := GetEnvironmentVariable('CommonProgramFiles');
  {$IF CompilerVersion > 18.49}
  DBPath := DBPath + '\CodeGear Shared\Data\dbdemos.mdb';
  {$ELSE}
  DBPath := DBPath + '\Borland Shared\Data\dbdemos.mdb';
  {$IFEND}

  ADOConnection1.Connected := False;
  //ڑ̍쐬(pX[hȂ̏ꍇ)
  ConnectStr                      := 'Provider=Microsoft.Jet.OLEDB.4.0';
  ConnectStr                      := ConnectStr + ';Data Source='+ DBPath;
  ADOConnection1.ConnectionString := ConnectStr;
  ADOConnection1.Mode             := cmReadWrite;
  ADOQuery1.Connection            := ADOConnection1;

  //NG[s
  try
    with ADOQuery1 do begin
      Close;
      SQL.Clear;
      SQL.Add('select * from customer');
      Open;
    end;
  except
    exit;
  end;

  //R[h
  RecCnt := ADOQuery1.RecordCount;
  //ڂ̐
  FCnt := ADOQuery1.FieldCount;

  //ݔ͈͂̃ZNA
  StartRow    := 7;
  StartRowStr := 'C' + IntToStr(StartRow);
  EndRowStr   := 'F' + IntToStr(StartRow + RecCnt - 1);
  xlfClearRange(StartRowStr,EndRowStr);

  LockWindowUpdate(PanelLeft.Handle);

  Screen.Cursor := crHourGlass;
  //Jn
  TStart := TimeGetTime;

  //3s
  for j := 0 to 2 do begin
    //Variantz쐬.̂߂Lock
    OleArray := VarArrayCreate([0, RecCnt - 1, 0, FCnt -1 ],VarVariant);
    VarArrayLock(OleArray);

    //擪zɃf[^
    with ADOQuery1 do begin
      First;
      for i:=0 to RecCnt-1 do begin
        OleArray[i,0] := FieldByName('CustNo').AsInteger;
        OleArray[i,1] := FieldByName('Company').AsString;
        OleArray[i,2] := FieldByName('Addr1').AsString;
        OleArray[i,3] := FieldByName('LastInvoiceDate').AsDateTime;
        Next;
      end;
    end;
    
    //GNZɔzf[^𑗂
    xlfExcelSheet.Range[StartRowStr,EndRowStr].Value := OleArray;
    //VariantzUnLockċɂ
    VarArrayUnLock(OleArray);
    VarClear(OleArray);
  end;
  ADOQuery1.Close;

  //I
  TEnd := TimeGetTime;
  Screen.Cursor := crDefault;

  LockWindowUpdate(0);
  //sԂ\
  Memo2.Text := IntToStr(TEnd-TStart) + ' ms ';

  //ۑƂɂ(܂ύXȂ)
  xlfBookSaved := True;
end;

//=============================================================================
//  RangeIuWFNgCopyFromRecordset\bhgp
//  oAgzɂ@ɋ߂x҂ł
//  DelphigꍇC̕@ԃm[}ȕ@mȂ
//=============================================================================
procedure TplExcelFormEx2.Button3Click(Sender: TObject);
var
  DBPath      : String;
  ConnectStr  : String;
  RecCnt      : Integer;
  i           : Integer;
  StartRow    : Integer;
  StartRowStr : String;
  EndRowStr   : String;
  TStart      : DWORD;
  TEnd        : DWORD;
begin
  //ADO֌W̐ݒ
  //܂f[^x[Xt@C̏ꏊDBPathɑ
  DBPath := GetEnvironmentVariable('CommonProgramFiles');
  {$IF CompilerVersion > 18.49}
  DBPath := DBPath + '\CodeGear Shared\Data\dbdemos.mdb';
  {$ELSE}
  DBPath := DBPath + '\Borland Shared\Data\dbdemos.mdb';
  {$IFEND}

  ADOConnection1.Connected := False;
  //ڑ̍쐬(pX[hȂ̏ꍇ)
  ConnectStr                      := 'Provider=Microsoft.Jet.OLEDB.4.0';
  ConnectStr                      := ConnectStr + ';Data Source=' + DBPath;
  ADOConnection1.ConnectionString := ConnectStr;
  ADOConnection1.Mode             := cmReadWrite;
  ADOQuery1.Connection            := ADOConnection1;

  //NG[s
  //RecCntR[h.ADOQuery1.RecordCountł擾\
  try
    with ADOQuery1 do begin
      Close;
      SQL.Clear;
      SQL.Add('select CustNo, Company, Addr1, LastInvoiceDate from customer');
      Open;
    end;
  except
    exit;
  end;

  //R[h
  RecCnt := ADOQuery1.RecordCount;

  //ݔ͈͂̃ZNA
  StartRow    := 7;
  StartRowStr := 'C' + IntToStr(StartRow);
  EndRowStr   := 'F' + IntToStr(StartRow + RecCnt - 1);
  xlfClearRange(StartRowStr,EndRowStr);

  LockWindowUpdate(PanelLeft.Handle);

  Screen.Cursor := crHourGlass;
  //Jn
  TStart := TimeGetTime;

  for i := 1 to 3 do begin
    //ADORecordsetIuWFNg̓e[NV[gɃRs[
    xlfExcelSheet.Range[StartRowStr,StartRowStr].
               CopyFromRecordset(ADOQuery1.Recordset, EmptyParam, EmptyParam);
  end;
  ADOQuery1.Close;

  //I
  TEnd := TimeGetTime;
  Screen.Cursor := crDefault;

  LockWindowUpdate(0);
  //sԂ\
  Memo3.Text := IntToStr(TEnd - TStart) + ' ms ';

  //ۑƂɂ(܂ύXȂ)
  xlfBookSaved := True;
end;

end.
